Package net.shibboleth.idp.attribute.resolver.spring.dc

# Class AbstractDataConnectorParser

java.lang.Object
org.springframework.beans.factory.xml.AbstractBeanDefinitionParser
org.springframework.beans.factory.xml.AbstractSingleBeanDefinitionParser
net.shibboleth.shared.spring.custom.AbstractCustomBeanDefinitionParser
net.shibboleth.idp.attribute.resolver.spring.BaseResolverPluginParser
net.shibboleth.idp.attribute.resolver.spring.dc.AbstractDataConnectorParser

All Implemented Interfaces:
  `BeanDefinitionParser`

Direct Known Subclasses:
  `AbstractSAMLDataConnectorParser`, `ContextDerivedDataConnectorParser`, `EntityAttributesDataConnectorParser`, `HTTPDataConnectorParser`, `LDAPDataConnectorParser`, `PairwiseIdDataConnectorParser`, `RDBMSDataConnectorParser`, `ScriptedDataConnectorParser`, `StaticDataConnectorParser`, `StorageServiceDataConnectorParser`, `SubjectDataConnectorParser`

public abstract class AbstractDataConnectorParser extends BaseResolverPluginParser
Base spring bean definition parser for data connectors. DataConnector implementations should provide a custom BeanDefinitionParser by extending this class and overriding the `doParse(Element, ParserContext, BeanDefinitionBuilder)` method to parse any additional attributes or elements it requires. Standard attributes and elements defined by the ResolutionPlugIn and DataConnector schemas will automatically attempt to be parsed.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ATTR_EXPORT_NAMES`
Which attributes to export.
`static final String`
`ATTR_FAIL_FAST`
Failfast LDAP, Realtional, Stored, SimpleAggregationSAML.
`static final String`
`ATTR_NORETRYDELAY`
Delay in retrying failed connector.
`static final QName`
`ELEMENT_NAME`
Element name.
`static final Boolean`
`FAIL_FAST_DEFAULT`
Failfast default.
`static final QName`
`FAILOVER_DATA_CONNECTOR_ELEMENT_NAME`
Failover data connector attribute name.
`private final org.slf4j.Logger`
`log`
Log4j logger.

### Fields inherited from class net.shibboleth.shared.spring.custom.AbstractCustomBeanDefinitionParser

`CUSTOM_PARSER_PROPERTIES_LOCATION`

### Fields inherited from class org.springframework.beans.factory.xml.AbstractBeanDefinitionParser

`ID_ATTRIBUTE, NAME_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`AbstractDataConnectorParser()`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`doParse(Element config, ParserContext parserContext, BeanDefinitionBuilder builder)`
`protected String`
`getLogPrefix()`
Return a string which is to be prepended to all log messages.

### Methods inherited from class net.shibboleth.idp.attribute.resolver.spring.BaseResolverPluginParser

`failOnDependencies, getActivationCondition, getDefinitionId, warnOnDependencies`

### Methods inherited from class net.shibboleth.shared.spring.custom.AbstractCustomBeanDefinitionParser

`getCustomProperty, registerBeanDefinition`

### Methods inherited from class org.springframework.beans.factory.xml.AbstractSingleBeanDefinitionParser

`doParse, getBeanClass, getBeanClassName, getParentName, parseInternal`

### Methods inherited from class org.springframework.beans.factory.xml.AbstractBeanDefinitionParser

`parse, postProcessComponentDefinition, resolveId, shouldFireEvents, shouldGenerateId, shouldGenerateIdAsFallback, shouldParseNameAsAliases`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### ELEMENT_NAME

@Nonnull public static final QName ELEMENT_NAME
Element name.

### ATTR_NORETRYDELAY

@Nonnull @NotEmpty public static final String ATTR_NORETRYDELAY
Delay in retrying failed connector.

See Also:
  - Constant Field Values

### ATTR_EXPORT_NAMES

@Nonnull @NotEmpty public static final String ATTR_EXPORT_NAMES
Which attributes to export.

See Also:
  - Constant Field Values

### ATTR_FAIL_FAST

@Nonnull @NotEmpty public static final String ATTR_FAIL_FAST
Failfast LDAP, Realtional, Stored, SimpleAggregationSAML.

See Also:
  - Constant Field Values

### FAIL_FAST_DEFAULT

@Nonnull public static final Boolean FAIL_FAST_DEFAULT
Failfast default.

### FAILOVER_DATA_CONNECTOR_ELEMENT_NAME

@Nonnull public static final QName FAILOVER_DATA_CONNECTOR_ELEMENT_NAME
Failover data connector attribute name.

### log

@Nonnull private final org.slf4j.Logger log
Log4j logger.

## Constructor Details

### AbstractDataConnectorParser

public AbstractDataConnectorParser()

## Method Details

### doParse

protected void doParse(@Nonnull Element config, @Nonnull ParserContext parserContext, @Nonnull BeanDefinitionBuilder builder)

Overrides:
  `doParse` in class `BaseResolverPluginParser`

### getLogPrefix

@Nonnull @NotEmpty protected String getLogPrefix()
Return a string which is to be prepended to all log messages.

Overrides:
  `getLogPrefix` in class `BaseResolverPluginParser`
Returns:
  "Data Connector: '<definitionID>' :"